/**
* @file main.c
*
* Copyright (c) 2004 Atmel.
*
* @brief ̕AT90PWM3p̊ȒP۸т޽񋟂܂B
*
* @version 1.0 (CVS revision : 1.7)
* @date 2006/03/08 17:02:35
* @author raubree
*****************************************************************************/

#include "config.h"
#include "lib_mcu/compiler.h"
#include "lib_mcu/mcu.h"
#include "inavr.h"
#include <stdio.h>

#pragma vector = TIMER0_COMPA_vect
__interrupt void Tech(void);

#pragma vector = ADC_vect
__interrupt void Read_Measure(void);

#define MAX_PWM		2666	// 64MHz(PLLg)/2666/2=12kHz(PWMg)

#define MAX_THETA	80		// ~6/1
#define K_scal		16		// pxϕɎgp

volatile U8 Flag_IT_timer0=0, Flag_IT_ADC=0 ;
U16 Softcounter = 0 ;

S16 Omega_meas;
S16 Omega_ref = 100;
S16 Command = 0;

U16 amplitude , OmegaTe = 64 ;
U8  direction = 0 ;
U16 PWM0, PWM1, PWM2;

#define DeadTime		32								// 32:َ=0.5s
#define MAX_AMPLITUDE	((MAX_PWM / 2) - DeadTime)

void init(void);
void ADC_Init(void);
void ADC_start_conv(void);
void DAC_Init(void);
void PSC_Init(unsigned int ot0,  unsigned int ot1);
void PSC0_Load (unsigned int dt0, unsigned int dt1);
void PSC1_Load (unsigned int dt0, unsigned int dt1);
void PSC2_Load (unsigned int dt0, unsigned int dt1);
void PSC_Load (unsigned int dt0a,  unsigned int dt1a,
			   unsigned int dt0b,  unsigned int dt1b,
			   unsigned int dt0c,  unsigned int dt1c);
S16 mc_control_speed_16b(S16 speed_ref , S16 speed_measure);
U16 controlVF(U16 Omega);
void SVPWM(U16 amp, U16 Omega);
S16 read_acquisition(void) ;

void main(void)
{
  /* CKDIV8˭ނ̌ʂ苎 */
  CLKPR = 0x80;
  CLKPR = 0x00;

  init();
//  DAC_Init();		/* PC7o͂ƂĂ̎gp]ނȂAD/AϊȂłB
  ADC_Init();

  PSC_Init(0x00, MAX_PWM);

  while(1)
  {
	if (Flag_IT_timer0)
	{
	  ADC_start_conv();
	  Flag_IT_timer0=0;
	  // ĳőxiK𐶐
/*	  Softcounter += 1 ;
	  if (Softcounter ==  2500) {
		Omega_ref = -400 ;
	  } //-128; }
	  if (Softcounter == 5000)
	  {
		Omega_ref= -200 ;
	  }
	  if (Softcounter == 7500)
	  {
		Omega_ref= 200 ;
	  }
	  if (Softcounter == 10000)
	  {
		Omega_ref= 400 ;
		Softcounter = 0 ;
	  }*/

	}
	if (Flag_IT_ADC)
	{

	  // A/Dϊ̑葬x擾
	  Omega_meas = ((U32)63 * Omega_meas + read_acquisition() )/ 64;
//	  Omega_meas = read_acquisition();

	  // Œqg(PI䕔)vZ
//	  Command = mc_control_speed_16b(Omega_ref,Omega_meas);		// HJԂł̎gp̂
//	  Command = Omega_ref ;										// ꂽiKł̖
	  Command = ((512 - Omega_meas)*20) / 10;					// ϒRł̖
//	  Command = (25 * (256 + 18 - Omega_meas))/8;				// 0`10V͂̉ϒRł̖

	  // Ǘ: ƐΒl𒊏o
	  if (Command > (S16)(0) ) {
		direction = 0 ;
		OmegaTe = Command;
	  }
	  else {
		direction = 1 ;
		OmegaTe = (~Command) + 1;
	  }

	  // ------------------------ V/f --------------------------
	  amplitude = controlVF(OmegaTe);
	  if (amplitude > MAX_AMPLITUDE) { amplitude = MAX_AMPLITUDE ; }

	  // ------------ ޸PWMZ@ -----------------
	  SVPWM(amplitude, OmegaTe) ;

	  // -------- Vޭè قPSCɐݒ -----------
	  if (direction==0)
	  {
		PSC_Load (PWM0, PWM0+DeadTime, PWM1, PWM1+DeadTime, PWM2, PWM2+DeadTime);
	  }
	  else
	  {
		PSC_Load (PWM0, PWM0+DeadTime, PWM2, PWM2+DeadTime, PWM1, PWM1+DeadTime);
	  }

	  Flag_IT_ADC=0;		/* Flag_IT_ADCgpI */
	}
	/* ߓd͌ */
	if (( PIFR0 & (1<<PEV0A)) !=0 )
	{
	  /* ߓdł̌ */
	  Set_PC7();
	  Set_PC3();
	  Clear_PE1();
	  while (1) ;			/* JԂ */
	}
  }		/* while(1)I */
}		/* mainI */

// ̎(Ts=1ms)p荞ݏ
__interrupt void Tech(void) {
  Flag_IT_timer0=1;
}

// A/Dϊ(ϊI)p荞ݏ
__interrupt void Read_Measure(void) {
  Flag_IT_ADC=1;
}
